#pragma semicolon 1
#include <sourcemod>

public Plugin:myinfo = 
{
	name	= "Command List",
	author	= "wS (World-Source.Ru)",
	version	= "1.0.1"
};

new Handle:cmdlist_menu_title, Handle:wS_MENU, wS_Item[MAXPLAYERS+1];

public OnPluginStart()
{
	cmdlist_menu_title = CreateConVar("cmdlist_menu_title", "Доступные Команды:");
	HookConVarChange(cmdlist_menu_title, cvar_changed);

	RegConsoleCmd("cmdlist", cmdlist);
	RegServerCmd("cmdlist_reload", cmdlist_reload);

	wS_CreateMenu();
}

public cvar_changed(Handle:var, const String:old[], const String:NewValue[])
{
	if (wS_MENU != INVALID_HANDLE)
	{
		decl String:text[150]; Format(text, 150, "%s\n \n", NewValue);
		SetMenuTitle(wS_MENU, text);
	}
}


///


bool:wS_CreateMenu()
{
	if (wS_MENU != INVALID_HANDLE)
	{
		CloseHandle(wS_MENU);
		wS_MENU = INVALID_HANDLE;
	}
	new Handle:kv = CreateKeyValues("command_list");
	if (!FileToKeyValues(kv, "command_list.txt") || !KvGotoFirstSubKey(kv, true))
	{
		CloseHandle(kv);
		return false;
	}
	wS_MENU = CreateMenu(wS_MENU_CallBack);
	decl String:text[150], String:command[25]; GetConVarString(cmdlist_menu_title, text, 150);
	Format(text, 150, "%s\n \n", text); SetMenuTitle(wS_MENU, text);
	do
	{
		if (KvGetSectionName(kv, command, 25))
		{
			KvGetString(kv, "text", text, 150, "Описание команды отсутствует.");
			AddMenuItem(wS_MENU, text, command);
		}
	}
	while (KvGotoNextKey(kv, true));
	CloseHandle(kv);
	return true;
}


///


public wS_MENU_CallBack(Handle:menu, MenuAction:action, client, item)
{
	if (action != MenuAction_Select)
		return;

	wS_Item[client] = GetMenuSelectionPosition();
	decl String:text[150]; GetMenuItem(menu, item, text, 150);
	ReplaceString(text, 150, "--", "\n"); Format(text, 150, "%s\n \n", text);
	new Handle:panel = CreatePanel();
	DrawPanelText(panel, text);
	DrawPanelItem(panel, "<-");
	SendPanelToClient(panel, client, Panel_CallBack, 0);
	CloseHandle(panel);
}

public Panel_CallBack(Handle:menu, MenuAction:action, client, item)
{
	if (action == MenuAction_Select && wS_MENU != INVALID_HANDLE)
		DisplayMenuAtItem(wS_MENU, client, wS_Item[client], 0);
}


///


public Action:cmdlist(client, args)
{
	if (0 < client <= MaxClients)
	{
		if (wS_MENU != INVALID_HANDLE)
		{
			wS_Item[client] = 0;
			DisplayMenu(wS_MENU, client, 0);
		}
		else
			PrintToChat(client, "cstrike/command_list.txt отсутствует или пуст");
	}
	return Plugin_Handled;
}

public Action:cmdlist_reload(args)
{
	if (wS_CreateMenu()) PrintToServer("Меню перезагружено");
	else PrintToServer("cstrike/command_list.txt отсутствует или пуст");
	return Plugin_Handled;
}